#include "resource.h"                           // ID-Definitionen einbinden


class CEinsApp : public CWinApp                 // Fensterklasse
{
    public:
        BOOL InitInstance();                    // Start fr Dialogerzeugung modifizieren
};


#define MaxBreite  6                            // Breite der Schablone
#define MaxInhalt  MaxBreite*MaxBreite          // Lnge der Texte plus abschlieendes Zero-Byte
#define Drehungen  4                            // 360/90 Drehungen

#define GetSchabloneID(x,y) (ID_SCHABLONE+(x)+(y)*MaxBreite)
                                                // Makro zur Ermittlung der ID eines Schablonenelementes


class CEinsDlg : public CDialog
{
        typedef char TFeld[MaxBreite][MaxBreite];
                                                // bentigte Typen definieren
        typedef char TText[MaxInhalt+1];

    public:
        CEinsDlg(CWnd* pParent = NULL);         // Konstruktor
        enum { IDD = IDD_HAUPTDIALOG };         // DialogID festhalten

    protected:
        virtual BOOL OnInitDialog();            // Start modifizieren

        afx_msg void OnClose();                 // Dialog schlieen
        afx_msg void OnOK();                    // Enter-Taste abfangen
        afx_msg void OnNachricht();             // nderung der Nachricht
        afx_msg void OnErgebnis();              // nderung des Ergebnisses
        afx_msg void OnKeyItem();               // nderung der Schablone
        afx_msg void OnHScroll(int nSBCode, int nPos, CScrollBar* pScrollBar);
                                                // auf nderungen der Schablonenbreite reagieren
        afx_msg void OnRechnen();               // Kodierung/Dekodierung einleiten
        afx_msg void OnTest();                  // Schablone testen
        afx_msg void OnAbout();                 // Programminfo

    private:
        void UpdateRechnenButton();             // Button auf Kodierung bzw. Dekodierung ndern
        void UpdateBreite();                    // Schablonenbreite anzeigen
        void UpdateLength(int nTextID, int nLength);
                                                // Lnge der Nachricht/des Ergebnisses anzeigen
        void UpdateKey();                       // Schablone aktualisieren
        void ShowKey();                         // Ergebnis in Schablonenform anzeigen

        BOOL CheckKey();                        // Schablone berprfen
        void GetKey();                          // Schablone aus Bildschirmmaske lesen
        void CheckKeyItem(int X, int Y);        // Schablonenelemen anpassen
        void RemoveZeros(TText cText);          // Nullen entfernen

        void Kodieren();                        // eigentliche Kodierung
        void Dekodieren();                      // eigentliche Dekodierung
        void GetText(TFeld Key);                // Text aus einer Schablonenposition lesen
        void SetText(TFeld Key);                // Text durch ein Schablonenposition schreiben
        void Rotiere(TFeld Alt, TFeld Neu);     // Schablone rotieren

        int   m_EditFocus;                      // aktuelles Edit-Fenster
        TText m_Nachricht;                      // Nachricht
        TText m_Ergebnis;                       // Ergebnis
        int   m_NachrichtZeichen;               // Lnge der Nachricht in Zeichen
        int   m_ErgebnisZeichen;                // Lnge des Ergebnisses in Zeichen
        int   m_Zeichen;                        // Laufvariable beim Kodieren/Dekodieren
        TFeld m_Key;                            // Schablone
        int   m_Breite;                         // tatschliche Schablonenbreite
        int   m_Inhalt;                         // Anzahl der Schablonenelemente
        int   m_InhaltGesamt;                   // wie m_Inhalt, nur +1 bei ungerader
                                                // Spaltenbreite (Mittelloch)

        DECLARE_MESSAGE_MAP()                   // MessageHandler installieren
};
