#include <afxwin.h>                             // MFC-Definitionen einbinden
#include "zwei.h"                               // Headerfile einbinden


CZweiApp ZweiApp;                               // Programmklasse statisch erzeugen


virtual BOOL CZweiApp::InitInstance()           // Programmstart berladen
{
    Enable3dControls();                         // 3D-Look

    CZweiDlg dlg;                               // Dialog statisch erzeugen
    m_pMainWnd = &dlg;                          // Dialog als Fenster festhalten

    dlg.DoModal();                              // Dialog modal ausfhren

    return FALSE;                               
}


BEGIN_MESSAGE_MAP(CZweiDlg, CDialog)            // alle Messages weiterleiten
    ON_BN_CLICKED(ID_BUTTON_ADD, OnAdd)
    ON_BN_CLICKED(ID_BUTTON_RANDOM, OnRandom)
    ON_BN_CLICKED(ID_BUTTON_NEW, OnNew)
    ON_BN_CLICKED(ID_BUTTON_CALC, OnCalc)
    ON_BN_CLICKED(ID_BUTTON_ABOUT, OnAbout)

    ON_WM_CLOSE()
END_MESSAGE_MAP()


CZweiDlg::CZweiDlg(CWnd* pParent) : CDialog(IDD, pParent)
{                                               // Konstruktor
}                                               // keine Variablen zu initialisieren


virtual BOOL CZweiDlg::OnInitDialog()           // Dialogstart
{
    CDialog::OnInitDialog();                    // zur Basisklasse weiterleiten

    OnNew();                                    // Liste lschen
    ((CEdit*)GetDlgItem(ID_EDIT_ARBEITSZEIT))->SetFocus();      
                                                // Focus auf Arbeitszeitfeld setzen
    return FALSE;                               // Focus von Win95 nicht verndern
}


virtual void CZweiDlg::OnOK()                   // bei Druck von ENTER
{
    OnAdd();                                    // neue Aufgabendauer hinzufgen
}


void CZweiDlg::OnAdd()                          // Hinzufgen eines Elementes
{
    int nArbeitsZeit = GetDlgItemInt(ID_EDIT_ARBEITSZEIT,NULL,FALSE);
                                                // neue Arbeitszeit holen
    if (nArbeitsZeit==0)                        // mu grer 0 sein
    {
        MessageBox("Bitte zuerst die Arbeitszeit eingeben.","Problem",MB_OK|MB_ICONSTOP);
        return;                                 // Fehlermeldung, abbrechen
    }

    int nEingabe     = GetDlgItemInt(ID_EDIT_AUFGABE,NULL,FALSE);
                                                // neue Aufgabendauer holen
    if (nEingabe>nArbeitsZeit)                  // Aufgabendauer zu gro ?
    {
        MessageBox("Keine Aufgabe darf grer als die Arbeitszeit sein.","Problem",MB_OK|MB_ICONSTOP);
        return;                                 // Fehlermeldung, abbrechen
    }

    if (nEingabe>0)                             // Aufgabendauer mu grer 0 sein
    {
        char cConvert[40];                      
        sprintf(cConvert, "%i", nEingabe);      // in Zeichenkette umwandeln

        CListBox* pBox = (CListBox*)GetDlgItem(ID_LISTBOX);
        pBox->InsertString(0,cConvert);         // an erster Stelle in die Liste einfgen
        pBox->SetItemData(0,nEingabe);          

        sprintf(cConvert, "Dauer der Aufgabe %i:", pBox->GetCount()+1);
        SetDlgItemText(ID_TEXT_AUFGABE, cConvert);
                                                // Textfeld ber Aufgabendauer anpassen
    }
    else
        MessageBox("Eine Aufgabendauer von 0 ist nicht zulssig !","Problem",MB_OK|MB_ICONSTOP);
                                                // Fehlermeldung
}


void CZweiDlg::OnRandom()                       // Zufallserzeugung
{
#define MinAufgabenZeit    1                    // Konstanten definieren
#define MaxAufgabenZeit   20
#define ArbeitsZeit       25
#define AnzahlAufgaben 10000
#define GetRandom      (((unsigned int)rand()*MaxAufgabenZeit)/32768+MinAufgabenZeit)
                                                // Makro zur einfachen Ermittlung
                                                // einer Zufallsaufgabendauer
    srand(clock());                             // Zufallsgenerator initialisieren

    SetDlgItemInt(ID_EDIT_ARBEITSZEIT, ArbeitsZeit, FALSE);
                                                // Arbeitszeit anzeigen
    CListBox* pBox = (CListBox*)GetDlgItem(ID_LISTBOX);
    for (int Lauf=0; Lauf<AnzahlAufgaben-1; Lauf++)
    {
        int nNeueAufgabe = GetRandom;           // Zufallszahl

        char cConvert[40];
        sprintf(cConvert, "%i", nNeueAufgabe);  // in Zeichenkette umwandeln

        pBox->InsertString(0,cConvert);         // an erster Stelle einfgen
        pBox->SetItemData(0,nNeueAufgabe);

        if (Lauf%100==0)                        // Anzeige der Laufvariable
        {                                       // im Zufallsbutton, aber nicht zu oft
            char cConvert[6];
            sprintf(cConvert, "%i", Lauf);
            SetDlgItemText(ID_BUTTON_RANDOM, cConvert);
        }
    }

    int NeueAufgabe = GetRandom;                // letzter Durchlauf als Nachahmung
                                                // einer Benutzereingabe
    SetDlgItemInt(ID_EDIT_AUFGABE, NeueAufgabe, FALSE);
    OnAdd();
    SetDlgItemInt(ID_EDIT_AUFGABE, 0, FALSE);
    
    SetDlgItemText(ID_BUTTON_RANDOM, "&Zufall");// Zufallsbutton wiederherstellen

#undef MinAufgabenZeit                          // Konstanten entfernen
#undef MaxAufgabenZeit
#undef ArbeitsZeit
#undef AnzahlAufgaben
}


void CZweiDlg::OnNew()                          // Liste lschen
{
    CListBox* pBox = (CListBox*)GetDlgItem(ID_LISTBOX);
    pBox->ResetContent();                       // Liste lschen

    SetDlgItemText(ID_TEXT_AUFGABE, "Dauer der Aufgabe 1:");
                                                // Textfeld anpassen
}


void CZweiDlg::OnCalc()                         // Berechnung
{
    CListBox* pBox = (CListBox*)GetDlgItem(ID_LISTBOX);

    int nAufgabenAnzahl = pBox->GetCount();     // Anzahl Elemente bestimmen
    if (nAufgabenAnzahl==0)                     // Abbruch bei leerer Liste
    {
        MessageBox("Noch keine Aufgaben eingegeben.","Problem",MB_OK|MB_ICONSTOP);
        return;
    }

    int nArbeitsZeit = GetDlgItemInt(ID_EDIT_ARBEITSZEIT,NULL,FALSE);
                                                // Arbeitszeit holen
    if (nArbeitsZeit==0)                        // Abbruch bei ungltiger Dauer
    {
        MessageBox("Noch keine Arbeitszeit eingegeben.","Problem",MB_OK|MB_ICONSTOP);
        return;
    }
    
    int nPersonen            = 1;               // min. 1 Person ntig
    int nAufgabenEinerPerson = 0;               // noch keine Aufgaben verteilt
    int nAufgabenSumme       = 0;

    for (int Lauf=0; Lauf<nAufgabenAnzahl; Lauf++)
                                                // alle Aufgaben durchlaufen
    {
        int nAufgabe = pBox->GetItemData(Lauf); // nchste Aufgabe holen
        nAufgabenSumme += nAufgabe;             // Gesamtsumme bilden

        if (nAufgabenEinerPerson+nAufgabe > nArbeitsZeit)
                                                // ist Person berfordert ?
        {
            nPersonen++;                        // nchste Person anfordern
            nAufgabenEinerPerson = 0;    
        }

        nAufgabenEinerPerson += nAufgabe;       // Aufgabe zuteilen
    }

    char cInfo[80];                             
    sprintf(cInfo, "Es werden %i Personen bentigt, die im Durchschnitt %i Zeiteinheiten arbeiten",
                   nPersonen, nAufgabenSumme/nPersonen);
    MessageBox(cInfo, "Ergebnis", MB_OK|MB_ICONINFORMATION);
                                                // Anzahl Personen und durchschnittliche
                                                // Arbeitszeit ausgeben
}


void CZweiDlg::OnAbout()                        // Programminfo
{
    MessageBox("geschrieben von Stephan Brumme\nin Watcom C++ 10.6 mit MFC 3.2","ber...",MB_OK|MB_ICONINFORMATION);
}


void CZweiDlg::OnClose()                        // Programmende
{
    if (MessageBox("Wirklich beenden ?","Ende",MB_YESNO|MB_ICONQUESTION)==IDYES)
                                                // Sicherheitsabfrage
        CDialog::OnClose();                     
}
