#include "resource.h"                           // ID-Codes einbinden


typedef struct
{
    float Winkel, Laenge;
} tPolar;                                       // Typ fr Polarkoordinaten

#define Borsten         3                       // 3 Borsten insgesamt
#define BorstenPunkte   2*Borsten-1             // Mutterstartpunkt ist immer (0/0)
#define MaxAufloesung   0.5                     // Grenzwert fr Borstenlnge


class CDreiApp : public CWinApp                 // Basisklasse ableiten
{
    virtual BOOL InitInstance();                // Start berladen
};


class CDisplay : public CFrameWnd               // Zeichenflche
{
    public:
        CDisplay();                             // Konstruktor berladen

        afx_msg void OnPaint();                 // Neuzeichnen
        afx_msg void OnClose();                 // Programmende

    private:
        void CalcFractal(float StartX, float StartY, float Winkel, float Faktor, int nSchritt);
                                                // Fraktal berechnen
        CPaintDC* pDC;                          // Zeiger auf Zeichenklasse
        int MidX;                               // Mittelpunkt der Zeichenflche
        int MidY;
        tPolar nBorsten[BorstenPunkte];         // Borstenpunkte
        float OriginalLaenge;                   // die Originallnge

        DECLARE_MESSAGE_MAP()                   // MessageHandler installieren
};


class CDreiDlg : public CDialog                 // Dialogklasse ableiten
{
    public:
        CDreiDlg(CWnd* pParent = NULL);         // Konstruktor
        enum { IDD = IDD_DIALOG };              // ID merken

        void GetNumbers();                      // Dialog auslesen
        tPolar nBorsten[BorstenPunkte];         // Borstenpunkte
        int nRekursionstiefe;                   // max. Rekursionstiefe

    protected:
        virtual BOOL OnInitDialog();            // Dialogstart
        virtual void OnOK();                    // Eingabe von Enter

        afx_msg void OnZeichnen();              // explizite Zeichnen-Anforderung
        afx_msg void OnAbout();                 // Programminfo

        DECLARE_MESSAGE_MAP()                   // Messagehandler installieren
};
