#include <afxwin.h>                             // MFC einbinden
#include "vier.h"                               // Header laden


CVierApp VierApp;                               // Programm statisch erzeugen

CVierApp::InitInstance()                        // Start berladen
{
    Enable3dControls();                         // 3D-Look

    CVierDlg dlg;                               // Dialog statisch erzeugen
    m_pMainWnd = &dlg;                          // als Hauptfenster setzen
    dlg.DoModal();                              // modal ausfhren

    return FALSE;                               // alles ok
}


BEGIN_MESSAGE_MAP(CVierDlg, CDialog)            // Messages weiterleiten
    ON_BN_CLICKED(ID_BUTTON_HINZU, OnAdd)
    ON_BN_CLICKED(ID_BUTTON_VORHERSAGE, OnForecast)
    ON_BN_CLICKED(ID_BUTTON_ABOUT, OnAbout)
    
    ON_WM_CLOSE()
END_MESSAGE_MAP()


CVierDlg::CVierDlg(CWnd* pParent): CDialog(IDD, pParent)
{                                               // Konstruktor berladen
    m_MaxX = m_MaxY = 0;                        // noch keine Grenzen gesetzt

    memset(nQuadratien, 0, sizeof(nQuadratien));
                                                // Quadratien als leer markieren
}


CVierDlg::OnInitDialog()                        // Start verndern
{
    CDialog::OnInitDialog();                    // Grundklasse aufrufen

    SetDlgItemText(ID_BUTTON_HINZU, "&Gre setzen");
    SetDlgItemText(ID_TEXT_SIZE, "Gre von Quadratien noch nicht festgesetzt.");
                                                // Anwender an noch unbekannte
                                                // Gre Quadratiens erinnern
    ((CButton*)GetDlgItem(ID_BUTTON_VORHERSAGE))->EnableWindow(FALSE);
                                                
    return TRUE;                                // Focus kann Win95 setzen
}


void CVierDlg::OnOK()                           // bei Enter
{
    if (GetFocus()==(CButton*)GetDlgItem(ID_EDIT_Y))
                                                // falls Zeileneingabe
        (CButton*)GetDlgItem(ID_EDIT_X)->SetFocus();
                                                // ja, zur Spalteneingabe springen
    else
        OnAdd();                                // sonst Wolke hinzufgen
}


void CVierDlg::OnAdd()                          // Wolke hinzufgen
{
    if ((m_MaxX==0)&&(m_MaxY==0))               // noch keine Gre gesetzt ?
    {
        UpdateSize();                           // Gre einlesen
        return;                                 // abbrechen
    }

    int nX = (int)GetDlgItemInt(ID_EDIT_X);     // Spalte auslesen
    int nY = (int)GetDlgItemInt(ID_EDIT_Y);     // Zeile auslesen

    if (((nX*nY>=0)&&(nX+nY>=0))||(nX>m_MaxX)||(nY>m_MaxY))
    {                                           // ungltige Position ?
        MessageBox("Wolke liegt bereits in Quadratien\noder wird Quadratien nie erreichen.",
                   "Problem",MB_OK|MB_ICONSTOP);// Fehlermeldung ausgeben
        return;                                 // abbrechen
    }

    char cWolke[15] = "";                       // temporr
    sprintf(cWolke, "%i/%i", nY, nX);           // Koordinaten als Zeichenkette
    ((CListBox*)GetDlgItem(ID_LISTBOX))->InsertString(-1, cWolke);
                                                // an die Listbox anhngen
    GetQuadratien(nX,nY).bWestOst = BOOL(nX<nY);
    GetQuadratien(nX,nY).bNordSued = BOOL(nX>nY);
                                                // in Quadratien eintragen, dabei
                                                // Richtung bestimmen
    SetDlgItemText(ID_EDIT_X, "");              // Eingabefelder lschen
    SetDlgItemText(ID_EDIT_Y, "");

    ((CButton*)GetDlgItem(ID_BUTTON_VORHERSAGE))->EnableWindow(TRUE);

    (CButton*)GetDlgItem(ID_EDIT_Y)->SetFocus();// Focus auf Zeile setzen
}


void CVierDlg::OnForecast()                     // Wettervorhersage
{
    int nX, nY;
    int nRegen = 0;

    for (nX=0; nX<m_MaxX; nX++)                 // berall Niederschlagsmenge auf 
        for (nY=0; nY<m_MaxY; nY++)             // 0 setzen
            GetQuadratien(nX,nY).nNiederschlag = 0;

    BOOL bFertig = FALSE;                       // Schleifenbedingung
    while (!bFertig)
    {
        for (nX=m_MaxX; nX>-MaxX; nX--)
            for (nY=-MaxY; nY<m_MaxY; nY++)
                if (GetQuadratien(nX,nY).bWestOst)
                {                               // ostwrts ziehende Wolke
                    GetQuadratien(nX,nY).bWestOst = FALSE;
                                                // Wolke lschen
                    if (nX+TaktWestOst<=m_MaxX) // falls nchster Takt auch innerhalb
                                                // Quadratiens
                        GetQuadratien(nX+TaktWestOst,nY).bWestOst = TRUE;
                                                // Wolke an neuem Platz setzen
                }

        for (nY=m_MaxY; nY>-MaxY; nY--)
            for (nX=-MaxX; nX<m_MaxX; nX++)
                if (GetQuadratien(nX,nY).bNordSued)
                {                               // westwrts ziehende Wolke
                    GetQuadratien(nX,nY).bNordSued = FALSE;
                                                // Wolke lschen
                    if (nY+TaktNordSued<=m_MaxY)// falls nchster Takt auch innerhalb
                                                // Quadratiens
                        GetQuadratien(nX,nY+TaktNordSued).bNordSued = TRUE;
                                                // Wolke an neuem Platz setzen
                }

        for (nX = 0; nX<m_MaxX; nX++)
            for (nY = 0; nY<m_MaxY; nY++)
                if (GetQuadratien(nX,nY).bNordSued&&
                    GetQuadratien(nX,nY).bWestOst)
                                                // zwei Wolken ber einem Feld
                {
                    GetQuadratien(nX,nY).bNordSued = FALSE;
                    GetQuadratien(nX,nY).bWestOst = FALSE;
                                                // beide Wolken lschen
                    GetQuadratien(nX,nY).nNiederschlag++;
                                                // Niederschlag markieren
                    nRegen++;                   // Gesamtniederschlag erhhen
                }       
                
        bFertig = TRUE;                         // von leerem Quadratiens ausgehen
        for (nX = -MaxX; nX<m_MaxX; nX++)
            for (nY = -MaxY; nY<m_MaxY; nY++)
                if (GetQuadratien(nX,nY).bNordSued||
                    GetQuadratien(nX,nY).bWestOst)
                    bFertig = FALSE;            // falls eine Wolke gefunden,
                                                // neuer Schleifendurchlauf ntig
    }

    if (nRegen==0)                              // falls berhaupt kein Regen
        MessageBox("Es wird in Quadratien berhaupt nicht regnen.","Ergebnis",
                   MB_OK|MB_ICONINFORMATION);   // Meldung ausgeben
    else
    {
        char cHeadline[50] = "";                // berschrift
        sprintf(cHeadline, "Es wird in Quadratien %imal regnen:\n", nRegen);
    
        char cAusgabe[1000] = "";               // genaue Vorhersage
        for (nX = 0; nX<MaxX; nX++)
            for (nY = 0; nY<MaxY; nY++)
                if (GetQuadratien(nX,nY).nNiederschlag)
                                                // falls Niederschlag
                    sprintf(cAusgabe, "%s%imal in Quadrat (%i,%i)\n", cAusgabe,
                            GetQuadratien(nX,nY).nNiederschlag, nY, nX);
                                                // Koordinaten und Menge merken
        MessageBox(cAusgabe, cHeadline, MB_OK|MB_ICONINFORMATION);
                                                // anzeigen
    }

    ((CListBox*)GetDlgItem(ID_LISTBOX))->ResetContent();
}


void CVierDlg::OnAbout()                        // Programminfo
{
    MessageBox("geschrieben von Stephan Brumme\nin Watcom C++ 10.6 mit MFC 3.2",
               "ber...",MB_OK|MB_ICONINFORMATION);
}


void CVierDlg::OnClose()                        // Programmende
{
    if (MessageBox("Wirklich beenden ?","Ende",MB_YESNO|MB_ICONQUESTION)==IDYES)
        CDialog::OnClose();                     // Sicherheitsabfrage
}


void CVierDlg::UpdateSize()                     // Gre von Quadratien setzen
{
    int nX = (int)GetDlgItemInt(ID_EDIT_X);     // Spalte lesen
    int nY = (int)GetDlgItemInt(ID_EDIT_Y);     // Zeile lesen

    if ((nX<1)||(nY<1))                         // falls zu klein
    {
        MessageBox("Quadratien mu min. 1 Quadranten enthalten.\nAuerdem sind nur positive Quadrantenkoordinaten als Grenzen erlaubt.",
                   "Problem",MB_OK|MB_ICONSTOP);// Fehlermeldung
        return;                                 // Abbruch
    }

    if ((nX>=MaxX)||(nY>=MaxY))                 // falls zu gro
    {
        MessageBox("Dieses Quadratien ist zu gro.","Problem",MB_OK|MB_ICONSTOP);
        return;                                 // Fehlermeldung, abbrechen
    }

    m_MaxX = nX-1;                              // Eckpunkt im Sdosten bestimmen
    m_MaxY = nY-1;

    char cSize[50] = "";                        // fr Bildschirmausgabe
    sprintf(cSize, "Gre von Quadratien:\n von 0/0 bis %i/%i", m_MaxY, m_MaxX);
    SetDlgItemText(ID_TEXT_SIZE, cSize);        // setzen

    SetDlgItemText(ID_BUTTON_HINZU, "&Hinzu");  // Button ndern

    SetDlgItemText(ID_EDIT_X, "");              // Eingabefelder lschen
    SetDlgItemText(ID_EDIT_Y, "");

    (CButton*)GetDlgItem(ID_EDIT_Y)->SetFocus();// Focus setzen
}

