#include "resource.h"                           // ID-Kennungen laden


class CVierApp : public CWinApp                 // Basisklasse
{
    public:
        virtual BOOL InitInstance();            // Start berladen
};


#define TaktWestOst      3                      // Vorrcken in West-Ost-Richtung
#define TaktNordSued     2                      // Vorrcken in Nord-Sued-Richtung

#define MaxX            30                      // Maximale Spaltenanzahl
#define MaxY            30                      // Maximale Zeilenanzahl

#define GetX(x)            (x+MaxX)             // Spalte umrechnen
#define GetY(y)            (y+MaxY)             // Zeile umrechnen
#define GetQuadratien(x,y) (nQuadratien[GetX(x)][GetY(y)])
                                                // Koordinaten fr Quadratien
                                                // umrechnen

class CVierDlg : public CDialog                 // Dialogklasse
{
    public:
        CVierDlg(CWnd* pParent = NULL);         // Konstruktor berladen
        enum { IDD = ID_DIALOG };               // ID sichern

    protected:
        virtual BOOL OnInitDialog();            // Start verndern
        virtual void OnOK();                    // bei Enter

        afx_msg void OnAdd();                   // Wolke hinzufgen
        afx_msg void OnForecast();              // Wettervorhersage
        afx_msg void OnAbout();                 // Programminfo
        afx_msg void OnClose();                 // Programmende

    private:
        void UpdateSize();                      // Gre von Quadratien setzen
        
        int m_MaxX;                             // Gre Quadratiens
        int m_MaxY;

        typedef struct                          // Typdefinition einer Wolke
        {
            int nNiederschlag;                  // Anzahl Niederschlag
            BOOL bWestOst,bNordSued;            // ist Wolke dort vorhanden ?
        } tQuadrat;
        tQuadrat nQuadratien[GetX(MaxX)+1][GetY(MaxY)+1];
                                                // Quadratien deklarieren
                                                
        DECLARE_MESSAGE_MAP()                   // Message-Handler einbinden
};
