#include "afxwin.h"                             // MFC-Definitionen
#include "fuenf.h"                              // Headerfile einbinden


CFuenfApp FuenfApp;                             // Programm statisch erzeugen


virtual BOOL CFuenfApp::InitInstance()          // Start berladen
{
    Enable3dControls();                         // 3D-Stil

    CFuenfDlg dlg;                              // Dialog statisch erzeugen
    m_pMainWnd = &dlg;                          // Zeiger darauf eintragen
    
    dlg.DoModal();                              // modal ausfhren

    return FALSE;                               // fehlerfrei
}



BEGIN_MESSAGE_MAP(CFuenfDlg, CDialog)           // Messages weiterleiten
    ON_BN_CLICKED(ID_BUTTON_HINZU, OnAdd)
    ON_BN_CLICKED(ID_BUTTON_KENNT, OnKnows)
    ON_BN_CLICKED(ID_BUTTON_ABOUT, OnAbout)

    ON_LBN_SELCHANGE(ID_LISTBOX_KENNT_LINKS, OnLinks)
    ON_LBN_SELCHANGE(ID_LISTBOX_KENNT_RECHTS, OnRechts)
    ON_WM_CLOSE()
END_MESSAGE_MAP()


CFuenfDlg::CFuenfDlg(CWnd* pParent):CDialog(IDD, pParent)
                                                // Konstruktor
{
    nFocus = ID_LISTBOX_KENNT_LINKS;            // Focus auf linke Liste
    nPersonen = 0;
    memset(Bekanntschaften, FALSE, sizeof(Bekanntschaften));
    memset(KenntFest, FALSE, sizeof(KenntFest));
}


BOOL CFuenfDlg::OnInitDialog()                  // Dialoginitialisierung
{
    CDialog::OnInitDialog();                    // an Grundklasse weiterleiten

    AddToListBoxLinksRechts("Katrin", TRUE);    // Katrin einfgen, kennt Fest
    AddToListBoxLinksRechts("Robert", FALSE);   // Robert einfgen, kennt Fest nicht

    ((CListBox*)GetDlgItem(ID_LISTBOX_KENNT_LINKS))->SetCurSel(KatrinIndex);
    ((CListBox*)GetDlgItem(ID_LISTBOX_KENNT_RECHTS))->SetCurSel(KatrinIndex);
                                                // Katrin selektieren
    UpdateAlleBekanntschaften();
    UpdateEinzelneBekanntschaften();            // Katrins Freunde anzeigen

    return TRUE;
}


void CFuenfDlg::OnOK()                          // Entertaste
{
    OnAdd();                                    // Name zu den Listen hinzufgen
}


void CFuenfDlg::OnAdd()                         // Namen hinzufgen
{
    char cName[50];                             // temporr Namen speichern

    GetDlgItemText(ID_EDIT_NAMEN, cName, 49);   // Namen auslesen
    if (cName[0]==0)                            // falls keiner eingegeben
    {
        MessageBeep(0);                         // Piepton, Methode beenden
        return;
    }
    
    SetDlgItemText(ID_EDIT_NAMEN, "");          // Eingabefeld lschen

    AddToListBoxLinksRechts(cName,FALSE);       // Name zu Listen hinzufgen
}


void CFuenfDlg::OnKnows()                       // kennt-Button
{
    CListBox* pBoxLinks  = (CListBox*)GetDlgItem(ID_LISTBOX_KENNT_LINKS);
    CListBox* pBoxRechts = (CListBox*)GetDlgItem(ID_LISTBOX_KENNT_RECHTS);

    int nLinks  = pBoxLinks->GetCurSel();       // aktuelle Selektion holen
    int nRechts = pBoxRechts->GetCurSel();

    if ((nLinks==LB_ERR)||(nRechts==LB_ERR)||(nLinks==nRechts)) 
    {                                           // ungltige Auswahl oder gleicher Name
        MessageBeep(0);                         // Piepton, Methode beenden
        return;
    }

    if (((nLinks==KatrinIndex)&&(nRechts==RobertIndex))||
        ((nLinks==RobertIndex)&&(nRechts==KatrinIndex)))
    {                                           // Kombination Robert-Katrin ausschlieen
        MessageBox("Robert und Katrin sprechen nicht miteinander ber das Fest.","Problem",MB_OK|MB_ICONSTOP);
        return;
    }

    char cLinks[50], cRechts[50];               // Namen temporr speichern
    GetName(nLinks,cLinks);                     // linker Name
    GetName(nRechts,cRechts);                   // rechter Name
    
    char cWerKenntWen[110];                     // Kombination beider Namen
    sprintf(cWerKenntWen, "%s kennt %s", cLinks, cRechts);
    
    CListBox* pBox = (CListBox*)GetDlgItem(ID_LISTBOX_ALLE_BEKANNTSCHAFTEN);
    pBox->InsertString(-1,cWerKenntWen);        // Kombination ans Ende anhngen

    Bekanntschaften[nLinks][nRechts] = TRUE;
    UpdateAlleBekanntschaften();

    UpdateEinzelneBekanntschaften();            // Bildschirmanzeige anpassen
}


void CFuenfDlg::OnLinks()                       // Focus auf linke Liste
{
    nFocus = ID_LISTBOX_KENNT_LINKS;            // Focus speichern
    UpdateEinzelneBekanntschaften();            // Bildschirmanzeige anpassen
}


void CFuenfDlg::OnRechts()                      // Focus auf linke Liste
{
    nFocus = ID_LISTBOX_KENNT_RECHTS;           // Focus speichern
    UpdateEinzelneBekanntschaften();            // Bildschirmanzeige anpassen
}


void CFuenfDlg::OnAbout()                       // Programminfo
{
    MessageBox("programmiert von Stephan Brumme\nin Watcom C++ 10.6 mit MFC 3.2",
               "ber...", MB_OK|MB_ICONINFORMATION);
}


void CFuenfDlg::OnClose()                       // Programm beenden
{
    if (MessageBox("Wirklick beenden ?","Ende",MB_YESNO|MB_ICONQUESTION)==IDYES)
                                                // Sicherheitsabfrage
        CDialog::OnClose();
}


void CFuenfDlg::UpdateEinzelneBekanntschaften() // einzelne Bekanntschaften anzeigen
{
    CListBox* pBoxLinksRechts = (CListBox*)GetDlgItem(nFocus);
    CListBox* pBoxAlle = (CListBox*)GetDlgItem(ID_LISTBOX_ALLE_BEKANNTSCHAFTEN);
    CListBox* pBoxEinzeln = (CListBox*)GetDlgItem(ID_LISTBOX_EINZELNE_BEKANNTSCHAFTEN);

    char cName[50], cText[60];
    int nName = pBoxLinksRechts->GetCurSel();   // selektiertes Element holen

    GetMarkedName(nName, cName);                // Namen mit Markierung identifizieren
    sprintf(cText, "%s kennt:", cName);
    SetDlgItemText(ID_TEXT_EINZELNE_BEKANNTSCHAFTEN, cText);
                                                // berschrift der Einzelbekanntschaften
                                                // anpassen
    pBoxEinzeln->ResetContent();                // Liste lschen

    if (pBoxAlle->GetCount()>0)                 // nur falls bereits Bekanntschaften
        for(int Lauf=0; Lauf<MaxPersonen; Lauf++)// alle Bekanntschaften durchlaufen
            if (Bekanntschaften[nName][Lauf])   // nur wenn Einzelperson gemeint
            {
                char cFreund[50];               
                GetMarkedName(Lauf, cFreund);
                                                // Freund mit Markierung erkennen
                pBoxEinzeln->InsertString(-1,cFreund);
                                                // Freund in Liste eintragen
            }
}


void CFuenfDlg::UpdateAlleBekanntschaften()     // alle Bekanntschaften verknpfen
{
    BOOL bNeu = TRUE;                           // wahr, wenn neue Bekanntschaften verabeitet
    while (bNeu)
    {
        bNeu = FALSE;                           // von bearbeitetem Feld ausgehen
        
        for (int X=0; X<nPersonen; X++)         // alle Personen durchlaufen
            for (int Y=0; Y<nPersonen; Y++)     // alle mglichen Freunde
                if (X!=Y)                       // sich selbst ausschlieen
                {
                    if (!Bekanntschaften[X][Y]) // noch keine Bekanntschaft ?
                        if ((Bekanntschaften[X][Y]=Bekanntschaften[Y][X])==TRUE)
                            bNeu = TRUE;        // fast doch, eintragen & neues Feld
                        
                    if ((Y!=RobertIndex)&&Bekanntschaften[X][Y]&&!KenntFest[X])
                                                // falls nicht Robert der Freund und
                                                // das Fest nicht bekannt
                        if ((KenntFest[X]=KenntFest[Y])==TRUE)
                            bNeu = TRUE;        // wenn Fest bekannt neues Feld
                }
    }

    UpdateRobert();                             // Bildschirmanzeige ndern
}


void CFuenfDlg::UpdateRobert()                  // wie oft Robert vom Fest erfhrt
{
    int nRobertWirdErzaehlt = 0;                // erstmal Fest unbekannt
    for (int Lauf=0; Lauf<nPersonen; Lauf++)    // alle Personen
        if (Bekanntschaften[RobertIndex][Lauf]&&KenntFest[Lauf])
                                                // wenn Freund und Fest bekannt
            nRobertWirdErzaehlt++;              // Anzahl Erzhlender erhhen

    char cText[50];

    sprintf(cText, "Robert wird %imal von dem Fest erzhlt.", nRobertWirdErzaehlt);
    SetDlgItemText(ID_TEXT_ROBERT, cText);      // Anzahl in Bildmitte anzeigen
}


void CFuenfDlg::AddToListBoxLinksRechts(LPCSTR cName, BOOL bFest)
{                                               // Namen zu beiden oberen Listen hinzufgen
    nPersonen++;
    
    ((CListBox*)GetDlgItem(ID_LISTBOX_KENNT_LINKS))->InsertString(-1, cName);
    ((CListBox*)GetDlgItem(ID_LISTBOX_KENNT_RECHTS))->InsertString(-1, cName);
                                                // beide Listen ndern
    int nIndex = ((CListBox*)GetDlgItem(ID_LISTBOX_KENNT_LINKS))->GetCount()-1;
    KenntFest[nIndex] = bFest;                  // Festkenntnis speichern
    UpdateAlleBekanntschaften();
}


void CFuenfDlg::GetName(int nIndex, char* cName)// Namen holen
{
    ((CListBox*)GetDlgItem(ID_LISTBOX_KENNT_LINKS))->GetText(nIndex, cName);
}


void CFuenfDlg::GetMarkedName(int nIndex, char* cName)
{                                               // wie GetName, nur mit Markierung
    CListBox* pBox = (CListBox*)GetDlgItem(ID_LISTBOX_KENNT_LINKS);

    pBox->GetText(nIndex, cName);
    if (KenntFest[nIndex])
        sprintf(cName, "%s*", cName);           // bei Festkenntnis Stern anhngen
}

