#include "resource.h"


class CFuenfApp : public CWinApp                // Basisklasse
{
    public:
        virtual BOOL InitInstance();            // Start berladen
};


#define KatrinIndex   0                         // Katrins Index
#define RobertIndex   1                         // Roberts Index
#define MaxPersonen 100

class CFuenfDlg : public CDialog                // Dialogklasse
{
    public:    
        CFuenfDlg(CWnd *pParent = NULL);        // Konstruktor

        enum { IDD = ID_DIALOG };               // ID aus der Resource

    protected:
        virtual BOOL OnInitDialog();            // Dialoginitialisierung

        afx_msg void OnOK();                    // Entertaste
        afx_msg void OnAdd();                   // Namen hinzufgen
        afx_msg void OnKnows();                 // kennt-Button
        afx_msg void OnLinks();                 // Focus auf linke Liste
        afx_msg void OnRechts();                // Focus auf rechte Liste
        afx_msg void OnAbout();                 // Programminfo
        afx_msg void OnClose();                 // Programm beenden

    private:
        void UpdateEinzelneBekanntschaften();   // einzelne Bekanntschaften anzeigen
        void UpdateAlleBekanntschaften();       // alle Bekanntschaften verknpfen
        void UpdateRobert();                    // wie oft Robert vom Fest erfhrt
        void AddToListBoxLinksRechts(LPCSTR cName, BOOL bFest);
                                                // Namen zu beiden oberen Listen hinzufgen
        void GetName(int nIndex, char* cName);  // Namen holen
        void GetMarkedName(int nIndex, char* cName);
                                                // wie GetName, nur mit Markierung
        int nFocus;                             // zuletzt markierter Name
        int nPersonen;                          // Anzahl Personen

        BOOL Bekanntschaften[MaxPersonen][MaxPersonen];
                                                // alle Bekanntschaften
        BOOL KenntFest[MaxPersonen];            // vom Fest Wissende
        
        DECLARE_MESSAGE_MAP()                   // Messagehandler installieren
};
